/**
 * @module dixim
 * @submodule common
 */
dixim.namespace('dixim.common');

/**
 * @module common
 * @submodule confirm-modal-dialog-view
 */

(function() {
var ConfirmModalDialogView;
var prototype;
var superConstructor;
var Event = dixim.event.Event;
var _ = dixim.ctt.ResourceBundle.get;
var ModalDialogView = dixim.common.ModalDialogView;

/**
 * @class ConfirmModalDialogView
 * @constructor
 * @param {Object} configs
 */
ConfirmModalDialogView = function(configs) {
    ModalDialogView.call(this, configs);
};

dixim.inherit(ConfirmModalDialogView, ModalDialogView);
dixim.common.ConfirmModalDialogView = ConfirmModalDialogView;
prototype = ConfirmModalDialogView.prototype;
superConstructor = ConfirmModalDialogView.superConstructor;

var CLOSE = 'close';
var OK = 'ok';

var TEMPLATE_BODY_CONTENT = [
    '<div>',
    '<div class="ctt-deletion-view-description dlg_main_msg">', '${description}', '</div>',
    '<div class="ctt-deletion-view-error dlg_main_msg error-text-field confirm-field">', '</div>',
    '<div class="ctt-deletion-view-progress dlg_main_msg error-text-field confirm-field">', '</div>',
    '</div>',
].join('');

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    var buttonText;

    configs = configs || {};

    buttonText = configs.buttonText || _('dialog_ok');

    configs.id = configs.id || '';
    configs.id = [configs.id, 'confirm-modal-dialog-'].join('');
    configs.bodyContent = TEMPLATE_BODY_CONTENT.
        replace('${description}', configs.description);

    configs.closeButton = dixim.proxy(this.hide, this);
    configs.buttons = [
        {
            text: _('dialog_close'),
            click: dixim.proxy(this.hide, this),
        },
        {
            text: buttonText,
            click: dixim.proxy(this._clickOk, this),
        },
    ];

    superConstructor.prototype._initialize.call(this, configs);
};

prototype._clickOk = function() {
    this.dispatchEvent(new Event(OK));
};

}());
