/**
 * @module dixim
 * @submodule download
 */
dixim.namespace('dixim.download');

/**
 * @module download
 * @submodule setting-menu-dialog-view
 */

(function() {
var SettingMenuDialogView;
var prototype;
var superConstructor;
var ModalDialogView = dixim.common.ModalDialogView;
var Event = dixim.event.Event;
var _ = dixim.ctt.ResourceBundle.get;

/**
 * @class SettingMenuDialogView
 * @constructor
 * @param {Object} configs
 */
SettingMenuDialogView = function(configs) {
    ModalDialogView.call(this, configs);
};

dixim.inherit(SettingMenuDialogView, ModalDialogView);
dixim.download.SettingMenuDialogView = SettingMenuDialogView;
prototype = SettingMenuDialogView.prototype;
superConstructor = SettingMenuDialogView.superConstructor;

var HISTORY = 'history';
var CHECK_RESERVATION = 'checkReservation';

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    configs = configs || {};

    configs.id = configs.id || '';
    configs.id = [configs.id, 'setting-menu-dialog-'].join('');

    configs.title = _('dialog_title_setting');
    configs.closeButton = dixim.proxy(this.hide, this);
    configs.buttons = [
        {text: _('dialog_close'), click: dixim.proxy(this.hide, this)},
    ];

    configs.lists = [];
    configs.lists.push({
        text: _('download_setting_menu_transfer_history'),
        click: dixim.proxy(this._clickHistory, this),
    });
    configs.lists.push({
        text: _('download_setting_menu_check_reservation'),
        click: dixim.proxy(this._clickCheckReservation, this),
    });

    superConstructor.prototype._initialize.call(this, configs);
};

prototype._clickHistory = function() {
    this.dispatchEvent(new Event(HISTORY));
};

prototype._clickCheckReservation = function() {
    this.dispatchEvent(new Event(CHECK_RESERVATION));
};

}());
