/**
 * @module ctt
 * @submodule confirmation-wizard-move-item-view
 */
(function() {
var Event = dixim.event.Event;
var WizardPageView = dixim.ctt.WizardPageView;
var _ = dixim.ctt.ResourceBundle.get;
var $ = dixim.ctt.jQuery;

var ConfirmationWizardMoveItemView;
var prototype;
var superConstructor;

/**
 * @class ConfirmationWizardMoveItemView
 * @extends WizardPageView
 * @constructor
 * @param {Object} configs
 */
ConfirmationWizardMoveItemView = function(configs) {
  WizardPageView.call(this, configs);
};
dixim.inherit(ConfirmationWizardMoveItemView, WizardPageView);
dixim.ctt.ConfirmationWizardMoveItemView = ConfirmationWizardMoveItemView;
prototype = ConfirmationWizardMoveItemView.prototype;
superConstructor = ConfirmationWizardMoveItemView.superConstructor;

var TEMPLATE = ['<div class="ctt-confirmation-wizard-page-view">',
                  '<div class="ctt-confirmation-wizard-page-view-description"></div>',
                  '<div class="ctt-confirmation-wizard-page-view-caution">${caution}</div>',
                '</div>'].join('');

/**
 * Triggered when the view has been rendered.
 *
 * @event render
 */
var RENDER = 'render';

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
  var buttons;
  var cfg = {};

  cfg.title = _('ctt_download_wizard_title');
  cfg.bodyContent = TEMPLATE.replace('${caution}', _('ctt_confirmation_wizard_move_item_caution'));

  cfg = dixim.extend(cfg, configs);
  buttons = [
    {
      text: _('ctt_transfer_wizard_button_label_yes'),
      click: $.proxy(this._didClickNext, this)
    },
    {
      text: _('ctt_transfer_wizard_button_label_back'),
      click: $.proxy(this._didClickBack, this)
    },
    {
      text: _('ctt_transfer_wizard_button_label_cancel'),
      click: $.proxy(this._didClickCancel, this),
      align: 'left'
    }
  ];

  cfg.buttons = buttons;
  superConstructor.prototype._initialize.call(this, cfg);
};

prototype._didRenderDialog = function(e) {
  superConstructor.prototype._didRenderDialog.call(this, e);
};

prototype._didClickNext = function(e) {
  this.dispatchEvent(new Event('next'));
};

prototype._didClickBack = function(e) {
  this.dispatchEvent(new Event('back'));
};

prototype._didClickCancel = function(e) {
  this.dispatchEvent(new Event('cancel'));
};

prototype.setDescription = function() {
  var s;

  s = _('ctt_confirmation_wizard_move_item_description');
  $('.ctt-confirmation-wizard-page-view-description', this._view).html(s);
};

}());
